<!DOCTYPE html>
<html lang="en">
  <head>
    <meta charset="UTF-8" />
    <meta name="viewport" content="width=device-width, initial-scale=1.0" />
    <title>Document</title>
  </head>
  <body></body>
</html>

<script>
  // Khai báo lớp
  class Car {
    // Khai báo thuộc tính
    _name;
    _year;

    // Khai báo phương thức khởi tạo
    constructor(paramName, paramYear) {
      this._name = paramName;
      this._year = paramYear;
    }

    // Phương thức Getter
    getName() {
      return this._name;
    }

    getYear() {
      return this._year;
    }

    // Phương thức Setter
    setName(paramName) {
      this._name = paramName;
    }

    setYear(paramYear) {
      this._year = paramYear;
    }

    // Phương thức khác
    getAge() {
      let today = new Date().getFullYear();

      return today - this._year;
    }
  }

  class Retangle {
    _width;
    _height;

    constructor(paramWidth, paramHeight) {
      this._width = paramWidth;
      this._height = paramHeight;
    }

    getArea() {
      return this._width * this._height;
    }
  }

  // Hình vuông kế thừa hình chữ nhật (Hình vuông là hình chữ nhật)
  // Hình vuông có đầy đủ các thuộc tính và tính chất của hình chữ nhật
  class Square extends Retangle {
    // Thuộc tính phát triển thêm
    _description;

    constructor(paramLength, paramDescription = "Hình vuông") {
      super(paramLength, paramLength);

      this._description = paramDescription;
    }

    getPerimeter() {
      return 4 * this._height;
    }
  }

  var cars = [
    {
      name: "Toyota",
      year: 2019,
    },
    {
      name: "Vinfast",
      year: 2020,
    },
  ];

  console.log("Car:");

  // Khởi tạo các thực thể
  var toyota = new Car("Toyota", 2019);
  var vinFast = new Car("Vinfast", 2020);

  console.log(toyota);
  console.log(vinFast);
  console.log(toyota.getName());
  console.log(vinFast.getName());

  console.log(toyota.getYear());
  console.log(vinFast.getYear());

  toyota.setYear(2020);
  vinFast.setYear(2021);

  console.log(toyota.getYear());
  console.log(vinFast.getYear());

  console.log(toyota.getAge());
  console.log(vinFast.getAge());

  console.log("Retangle:");

  const retangle1 = new Retangle(10, 5);
  const retangle2 = new Retangle(20, 5);

  console.log(retangle1);
  console.log(retangle2);
  console.log(retangle1.getArea());
  console.log(retangle2.getArea());

  console.log("Square:");

  const square1 = new Square(5);
  const square2 = new Square(10, "Hình vuông to");

  console.log(square1);
  console.log(square2);
  console.log(square1.getArea());
  console.log(square2.getArea());
  console.log(square1.getPerimeter());
  console.log(square2.getPerimeter());

  console.log(retangle1 instanceof Retangle); // T
  console.log(retangle1 instanceof Square); // F
  console.log(square1 instanceof Retangle); // T
  console.log(square1 instanceof Square); // T

  // Hoisting
  a = a + 1;

  var a;
</script>
